;;; -*- Mode: Lisp; Package: CALC -*-
;;; Define semantic functions.

(in-package "CALC")

;;; Build sample programs.

;;; => 4
(setq ca (calc-parse :string "let x = 1 in let x = 2, y = x in y + x"))
(setq caa (calc-analyze ca :nt 'program))

;;; => 3
(setq cb (calc-parse :string "iter x from 4 until x * x - 7 * x + 15 = x"))
(setq cbb (calc-analyze cb :nt 'program))

;;; => 3
(setq cc (calc-parse :string "iter x from 3 until x * x - 7 * x + 15 = x"))
(setq ccc (calc-analyze cc :nt 'program))

;;; => diverges
(setq cd (calc-parse :string "iter x from 6 until x * x - 7 * x + 15 = x"))
;;;(setq cdd (calc-analyze cd :nt 'program))

;;; 1 + 2 => 3
(setq ce (calc-parse :string "let x = 0 in 1 + 2"))

;;; let x = 1 in 2 + x => 3
(setq cf (calc-parse :string "let x = 1 in 2 + x"))

;;; let x = 0 in 2 / x => "divide by zero"
(setq cg (calc-parse :string "let x = 0 in 2 / x"))

;;; let x = 2, y = x + 3 in x * y => 10,
(setq ch (calc-parse :string "let x = 2, y = x + 3 in x * y"))
