;;; -*- Mode:Lisp; Package: TL -*-
;;; Trivial Statement language

(in-package 'tl)

;;; Auxilliary functions for the attribute grammar

(defconstant dv-default t "Variable is assumed dead")

(defun init-env ()
  "The null environment."
  nil)

(defun update-denv (var dead denv)
  "Update value of var in denv with dead, removing the old value first."
  (acons var dead (set-difference denv (list (list var)) :key #'car)))

(defun merge-denv (denv1 denv2)
  "Union the two denv bying ANDing the values."
  (let ((varlist (union denv1 denv2 :key #'car))
	(newenv nil))
    (dolist (entry varlist newenv)
      (let* ((var (car entry))
	     (e1 (assoc var denv1))
	     (e2 (assoc var denv2))
	     (d1 (if e1 (cdr e1) dv-default))
	     (d2 (if e2 (cdr e2) dv-default)))
	(setf newenv (acons var (and d1 d2) newenv))))))

(defun eq-denv (denv1 denv2)
  "Return true iff two denv are equal."
  ;;(format t "~A ~A~%" denv1 denv2)
  (equal denv1 denv2))

(defun bb (var exp de)
  "Basic Block."
  (dolist (entry exp)
    (setf de (update-denv entry nil de)))
  (if (and var (not (find var exp)))
      (update-denv var t de)
      de))

    
  


