;;; -*- Mode: Lisp; Package: TL -*-
;;; Trivial Statement language

(in-package 'tl)

(defconstant true t)
(defconstant false nil)


;;; a few examples

(setf a1 (tl-parse :nt 'stmt :string "x:=1"))
(setf a2 (tl-parse :nt 'stmt :string "write x"))
(setf a3 (tl-parse :nt 'stmt :string "read x ; write x"))
(setf a4 (tl-parse :nt 'stmt
		:string	"while true do read x od ; write x"))
(setf a5 (tl-parse :nt 'stmt :string "while true do write x; read x od"))
(setf a6 (tl-parse :nt 'stmt :string "while true do read x; write x od"))

;;; Attribute the example syntax

(tl-dv-analyze a1 :nt 'stmt :context (init-env))

;;; ((X . T))

(tl-dv-analyze a2 :nt 'stmt :context (init-env))

;;; ((X))

(tl-dv-analyze a3 :nt 'stmt :context (init-env))

;;; ((X . T))

(tl-dv-analyze a4 :nt 'stmt :context '())

;;; ((X))

(tl-dv-analyze a5 :nt 'stmt :context '())

;;; ((X))

(tl-dv-analyze a6 :nt 'stmt :context '())

;;; ((X . T))


