;;; -*- Mode: Lisp; Package: SF -*-

(in-package 'sf)

;;; Build some sample assertions

(setf a1 (sf-parse :nt 'assert :string "{x=0} x:=x+1 {x=1} {true}*"))

(setf a2 (sf-parse :nt 'assert :string "{x=0} x:=x+1 {x=1}"))

(setf a3 (sf-parse :nt 'assert :string
		"{x=0} x:=x+1 {x=1} {x=1} x:=x+1 {x=2} {true}*"))

(setf a4 (sf-parse :nt 'assert :string
		"{true} x:=1 {x=1} {x=1} y:=1 {x=1 and y=1}
		       + y:=1 {y=1} {y=1} x:=1 {x=1 and y=1}")) 

;;; Attribute the sample assertions

(sf-unparse 'pred (sf-analyze a1 :nt 'assert))

;;; ((x = 1) => true) and true

(sf-unparse 'pred (sf-analyze a2 :nt 'assert))

;;; ((x = 1) => x = 1) and true

(sf-unparse 'pred (sf-analyze a3 :nt 'assert))

;;; ((x = 1) => x = 1) and (((x = 2) => true) and true)

(sf-unparse 'pred (sf-analyze a4 :nt 'assert))

;;; ((x = 1) => x = 1) and
;;; (((y = 1) => y = 1) and (((x = 1) and y = 1 => (x = 1) and y = 1) and true)
;;;  and (((x = 1) and y = 1 => (x = 1) and y = 1) and true))




